/* ITSP appB.9 - B.10 */

use gdp4cty, clear
sjlog using appB.9, replace
forvalues i = 1/4 {
	generate double lngdp`i' = log(gdp`i')
	summarize lngdp`i' 
}
sjlog close, replace
// stripdot using appB.9.log.tex

use gdp4cty, clear
local country US UK DE FR
local cc 1
foreach c of local country {
	generate double `c'gdp = gdp`cc'
	local ++cc
	}

sjlog using appB.9a, replace
local country US UK DE FR
foreach c of local country {
	generate double lngdp`c' = log(`c'gdp)
	summarize lngdp`c' 
	}
sjlog close, replace
// stripdot using appB.9a.log.tex

drop gdp
sjlog using appB.9b, replace
generate double gdptot = 0
foreach c of varlist *gdp {
	qui replace gdptot = gdptot + `c'
}
summarize *gdp gdptot
sjlog close, replace
// stripdot using appB.9b.log.tex

use gdp4cty, clear
sjlog using appB.10, replace
forvalues y = 1995(2)1999 {
	forvalues i = 2(2)4 {
		summarize gdp`i'_`y' 
	}
}
sjlog close, replace
// stripdot using appB.10.log.tex


sjlog using appB.11, replace
sysuse lifeexp,clear
foreach v of varlist lexp-safewater {
	summarize `v'
	correlate popgrowth `v' 
	scatter popgrowth `v'
}
sjlog close, replace


sjlog using appB.12, replace
use gdp4cty, clear
local ctycode 111 112 136 134
local i 0
foreach c of local ctycode {
	local ++i
	local rc "`rc' (`i'=`c')"
}
display "`rc'"
recode cc `rc', gen(newcc)
tabulate newcc
sjlog close, replace

sjlog using appB.13, replace
use gdp4cty, clear
local country US UK DE FR
local yrlist 1995 1999
forvalues i = 1/4 {  
	local cname: word `i' of `country'
	foreach y of local yrlist {
		rename gdp`i'_`y' gdp`cname'_`y'
	}
}
summarize gdpUS*
sjlog close, replace
// stripdot using appB.13.log.tex


sjlog using appB.13a, replace
use gdp4cty, clear
describe gdp*_*  
local country US UK DE FR
local yrlist 1995 1999
local ncty: word count country
tokenize `country'
forvalues i = 1/`ncty' { 
	foreach y of local yrlist {
		rename gdp`i'_`y' gdp``i''_`y'
	}
}
summarize gdpUS*
sjlog close, replace
// stripdot using appB.13a.log.tex
