* ITSP 10.2 -

set more off

use crspsubset, clear
g hiord=real(substr(string(permno),1,1))
bys cdate hiord: egen retport = mean(ret)
separate retport, by(hiord)
forv i=1/9 {
	bys cdate: egen index`i' = mean(retport`i') 
}
drop retport*
label def ind 1 Kappa 2 Lambda 3 Nu 4 Xi 5 Tau 6 Upsilon 7 Phi 8 Chi 9 Psi

sjlog using ch10.2, replace
qui levelsof hiord, local(indices)
local nind : word count `indices'
qui levelsof permno, local(firms)
local nf : word count `firms'
matrix retcorr = J(`nf', `nind', .)
sjlog close, replace
// stripdot using ch10.2.log.tex

sjlog using ch10.2a, replace
local n 0
qui gen meanret = .
qui gen ndays = .
local row = `nind' + 1
foreach f of local firms {
	qui correlate index1-index`nind' ret if permno == `f'
	matrix sigma = r(C)
	local ++n
	forvalues i = 1/`nind' {
		matrix retcorr[`n', `i'] = sigma[`row', `i']
	}
	summarize ret if permno == `f', meanonly
	qui replace meanret = r(mean) in `n'
	qui replace ndays = r(N) in `n'
}
sjlog close, replace
// stripdot using ch10.2a.log.tex

//	qui matrix accum Cov = index1-index`nind' ret if permno == `f', noconst dev 
//	matrix sigma = corr(1/r(N) * Cov)

sjlog using ch10.2b, replace
svmat double retcorr
qui egen double maxretcorr = rowmax(retcorr*) 
qui generate highcorr = .
forvalues i = 1/`nind' {
	qui replace highcorr = `i' if maxretcorr == retcorr`i' ///
	& !missing(maxretcorr) 
}
sjlog close, replace
// stripdot using ch10.2b.log.tex

sjlog using ch10.2c, replace
gsort -meanret highcorr 
label values highcorr ind
list permno meanret ndays highcorr in 1/50, noobs sep(0)
sjlog close, replace
// stripdot using ch10.2c.log.tex

set more on
