*  ITSP 10.4 -

sjlog using ch10.4, replace
use airquality, clear
drop if town == "Alburq"
generate tabrv = upper(substr(town, 1, 3))
summarize temp, meanonly
generate hightemp = (temp > r(mean) & !missing(temp))
label def tlab 0 "below mean temp" 1 "above mean temp"
label values hightemp tlab
scatter so2 temp, msize(tiny) mlabel(tabrv) mlabsize(vsmall) ///
saving(fig10_4_1, replace) scheme(s2mono)
scatter so2 precip, msize(tiny) mlabel(tabrv) mlabsize(vsmall) ///
by(hightemp) saving(fig10_4_2, replace) scheme(s2mono)
scatter so2 wind, msize(tiny) mlabel(tabrv) mlabsize(vsmall) ///
by(hightemp) saving(fig10_4_3, replace) scheme(s2mono)
sjlog close, replace
// stripdot using ch10.4.log.tex

label var precip "Mean precipitation indices"
label var so2 "Sulphur dioxide, mg/m3"
scatter so2 precip, msize(tiny) mlabel(tabrv) mlabsize(vsmall) ///
by(hightemp) saving(fig10_4_2, replace) scheme(s2mono)
graph display, ysize(4) xsize(5)
graph export fig10_4.eps, replace

sjlog using ch10.4a, replace
clear
serset clear
graph use fig10_4_1
serset dir
serset use
sort tabrv
save f10_4_1, replace
sjlog close, replace
// stripdot using ch10.4a.log.tex

sjlog using ch10.4b, replace
serset clear
graph use fig10_4_2
serset dir
serset set 0
serset use
sort tabrv
save f10_4_2, replace
serset set 1
serset use
sort tabrv
save f10_4_2a, replace

serset clear
graph use fig10_4_3
serset dir
serset set 0
serset use
sort tabrv
save f10_4_3, replace
serset set 1
serset use
sort tabrv
save f10_4_3a, replace
sjlog close, replace
// stripdot using ch10.4b.log.tex

sjlog using ch10.4c, replace
use f10_4_1, clear
merge tabrv using f10_4_2 f10_4_3, unique 
drop _merge
sort tabrv
merge tabrv using f10_4_2a, update unique
drop _merge
sort tabrv 
merge tabrv using f10_4_3a, update unique
drop _merge
save f10_4_all, replace
describe
summarize
sjlog close, replace
// stripdot using ch10.4c.log.tex
