* ITSP 12.1 -

set more off

sjlog using ch12.1, replace
type myregress.ado
sjlog close, replace
// stripdot using ch12.1.log.tex

/*
capture program drop myregress
program myregress, rclass
version 10.1
syntax varlist(ts) [if] [in], LAGVar(string) NLAGs(integer)
regress `varlist' `if' `in'
local nl1 = `nlags' - 1
forvalues i = 1/`nl1' {
	local lv "`lv' L`i'.`lagvar' + "
}
local lv "`lv'  L`nlags'.`lagvar'"
lincom `lv'
return scalar sum = `r(estimate)'
return scalar se = `r(se)'
end
*/

* webuse wpi1, clear

sjlog using ch12.1a, replace
use wpi1, clear
myregress wpi L(1/4).wpi t, lagvar(wpi) nlags(4)
return list
lincom   L.wpi+L2.wpi+L3.wpi+L4.wpi
sjlog close, replace
// stripdot using ch12.1a.log.tex

sjlog using ch12.1b, replace
rolling sum=r(sum) se=r(se) ,window(30) : ///
myregress wpi L(1/4).wpi t, lagvar(wpi) nlags(4)
sjlog close, replace
// stripdot using ch12.1b.log.tex

sjlog using ch12.1c, replace
tsset end, quarterly
label var end Endpoint
g lo = sum - 1.96 * se
g hi = sum + 1.96 * se
twoway rarea lo hi end, color(gs12) title("Sum of moving lag coefficients, approx. 95% CI") ///
||  tsline sum, legend(off) scheme(s2mono)
sjlog close, replace
// stripdot using ch12.1c.log.tex

graph display, xsize(5) ysize(4)
graph export fig12_1.eps, replace

set more on
