* ITSP 12.2 - 

set more off

sjlog using ch12.2, replace
type _gpctrange.ado
sjlog close, replace
// stripdot using ch12.2.log.tex

/*
capture program drop _gpctrange
*! _gpctrange v1.0.0  CFBaum 02dec2007
program _gpctrange 
	version 10.1
	syntax newvarname =/exp [if] [in] [, HI(integer 75) LO(integer 25) *]
	
	if `hi' <= `lo' | `hi' > 99 | `lo' < 1 {
		display as error "Percentiles `hi' `lo' invalid."
		error 198
	}
	tempvar touse phi plo
	mark `touse' `if' `in'
	quietly { 
		egen double `phi' = pctile(`exp') if `touse', `options' p(`hi')
		egen double `plo' = pctile(`exp') if `touse', `options' p(`lo')
		generate `typlist' `varlist' = `phi' - `plo' if `touse'
	}
end
*/

sjlog using ch12.2a, replace
sysuse auto, clear
bysort rep78: egen iqr = pctrange(price) if inrange(rep78, 3, 5)
bysort rep78: egen p8020 = pctrange(price) if inrange(rep78, 3, 5), ///
hi(80) lo(20)
tabstat iqr if inrange(rep78, 3, 5), by(rep78)
tabstat p8020 if inrange(rep78, 3, 5), by(rep78)
sjlog close, replace
// stripdot using ch12.2a.log.tex
