* ITSP 12.4 -

set more off

!cp mynormal_lf.101.ado mynormal_lf.ado
program drop _all
which mynormal_lf

sjlog using ch12.4, replace
type mynormal_lf.ado
sjlog close, replace
// stripdot using ch12.4.log.tex

/*
capt program drop mynormal_lf
program mynormal_lf
  version 10.1
  args lnf mu lnsigma
  quietly replace `lnf' = ln( normalden( $ML_y1,  `mu', exp(`lnsigma') ) )
end
*/

/*
capt program drop  mynormal Replay Estimate

program mynormal
	version 10.1
	if replay()  {
		if ("`e(cmd)'" != "mynormal") error 301
		Replay `0'
	}
	else Estimate `0'
end

program Replay
	syntax [, Level(cilevel) ]
	ml display, level(`level')
end
*/

!cp mynormal.101.ado mynormal.ado
program drop _all
which mynormal

sjlog using ch12.4a, replace
type mynormal.ado
sjlog close, replace
// stripdot using ch12.4a.log.tex

/*
program Estimate, eclass sortpreserve
	syntax varlist [if] [in]  [,  vce(passthru) Level(cilevel) * ]
	mlopts mlopts, `options'
	gettoken lhs rhs: varlist
	marksample touse
	local diparm diparm(lnsigma, exp label("sigma"))
	ml model lf  mynormal_lf (mu: `lhs' = `rhs') /lnsigma  ///
	if `touse', `vce' `mlopts' maximize `diparm'
	ereturn local cmd "mynormal"
	ereturn scalar k_aux = 1
	Replay, level(`level') 
end
sjlog close, replace
*/

sjlog using ch12.4b, replace
sysuse auto, clear
mynormal price mpg weight turn
sjlog close, replace
// stripdot using ch12.4b.log.tex

capt program drop mynormal_lf_d0
sjlog using ch12.4c, replace
type mynormal_lf_d0.ado
sjlog close, replace
// stripdot using ch12.4c.log.tex

/*
program mynormal_lf_d0
        version 10.1
        args todo b lnf
        tempvar mu 
        tempname lnsigma
        mleval `mu' = `b', eq(1)
        mleval `lnsigma' = `b', eq(2) scalar
        quietly {
                mlsum `lnf' = ln( normalden($ML_y1,`mu', exp(`lnsigma')) )
        }
end
*/


sjlog using ch12.4d, replace
ml model d0 mynormal_lf_d0 (mu: price = mpg weight turn) /lnsigma, ///
maximize nolog diparm(lnsigma, exp label("sigma")) 
ml display
sjlog close, replace
// stripdot using ch12.4d.log.tex

// !cp mynormal_lf_d0_c1.100.ado mynormal_lf_d0_c1.ado
// program drop _all
// which mynormal_lf_d0_c1

sjlog using ch12.4e, replace
type mynormal_lf_d0_c1.ado
sjlog close, replace
// stripdot using ch12.4e.log.tex

/*
capt program drop mynormal_lf_d0_c1
program mynormal_lf_d0_c1
        version 10.1
        args todo b lnf
        tempvar xb mu
        tempname a lnsigma
        mleval `a' = `b', eq(1) scalar
        mleval `xb' = `b', eq(2)
        mleval `lnsigma' = `b', eq(3) scalar
        quietly {
        		generate double `mu' = `xb' + `a'* $x1        	
                mlsum `lnf' = ln( normalden($ML_y1,`mu', exp(`lnsigma')) )
        }
end
sjlog close, replace
*/
/*
sjlog using ch12.4f, replace
program drop mynormal_lf_d0_c1
program mynormal_lf_d0_c1
        version 10.1
        args todo b lnf
        tempvar xb mu
        tempname a lnsigma
        mleval `a' = `b', eq(1) scalar
        mleval `xb' = `b', eq(2)
        mleval `lnsigma' = `b', eq(3) scalar
        quietly {
        		generate double `mu' = `xb' - exp(`a')* $x1        	
                mlsum `lnf' = ln( normalden($ML_y1,`mu', exp(`lnsigma')) )
        }
end
sjlog close, replace
*/

sjlog using ch12.4f, replace
global x1 mpg 
ml model d0 mynormal_lf_d0_c1 (a:) (mu: price = weight turn) /lnsigma, ///
maximize nolog diparm(lnsigma, exp label("sigma")) 
ml display
sjlog close, replace
// stripdot using ch12.4f.log.tex

sjlog using ch12.4g, replace
nlcom -exp([a]_cons)
sjlog close, replace
// stripdot using ch12.4g.log.tex
