* ITSP 12.6 -

set more off
sjlog using ch12.6, replace
type meanvar.ado
sjlog close, replace
// stripdot using ch12.6.log.tex

/*
capture program drop meanvar 
program meanvar
	version 10.1
	args lnf mu1 mu2 sigma1 sigma2
	qui replace `lnf' = ln(normalden($ML_y1, `mu1', `sigma1')) ///
	    if $disease == 0
	qui replace `lnf' = ln(normalden($ML_y1, `mu2', `sigma2')) ///
	    if $disease == 1
end
sjlog close, replace
*/

sjlog using ch12.6a, replace
sysuse auto, clear
global subsample foreign
generate byte iota = 1
ml model lf meanvar (mu1: price = iota) (mu2: price = iota) /sigma1 /sigma2
ml maximize, nolog
estimates store unconstr
sjlog close, replace
// stripdot using ch12.6a.log.tex


sjlog using ch12.6b, replace
nlcom ([sigma1]_b[_cons] - [sigma2]_b[_cons]) / ///
      ([sigma1]_b[_cons] + [sigma2]_b[_cons])
      
nlcom 2*_pi*sqrt(3) * (([mu1]_b[_cons] - [mu2]_b[_cons]) / ///
      ([sigma1]_b[_cons] + [sigma2]_b[_cons]))
sjlog close, replace
// stripdot using ch12.6b.log.tex

sjlog using ch12.6c, replace
constraint 1 [sigma1]_cons = [sigma2]_cons
ml model lf meanvar (mu1: price = iota) (mu2: price = iota) /sigma1 /sigma2, ///
   constraints(1)
ml maximize, nolog
estimates store constr
nlcom 2*_pi*sqrt(3) * (([mu1]_b[_cons] - [mu2]_b[_cons]) / ///
      ([sigma1]_b[_cons] + [sigma2]_b[_cons]))
sjlog close, replace
// stripdot using ch12.6c.log.tex

sjlog using ch12.6d, replace
lrtest unconstr constr
sjlog close, replace
// stripdot using ch12.6d.log.tex

sjlog using ch12.6e, replace
type onespell_part1.txt
sjlog close, replace
// stripdot using ch12.6e.log.tex

sjlog using ch12.6f, replace
type onespell_part2.txt
sjlog close, replace
// stripdot using ch12.6f.log.tex

