// itsp 13.00-

set more off
capt program drop _all
mata: mata clear

sjlog using ch13.00a, replace
type varextrema.ado
sjlog close, replace
// stripdot using ch13.00a.log.tex

do calcextrema.mata

sjlog using ch13.00b, replace
type calcextrema.mata
sjlog close, replace
// stripdot using ch13.00b.log.tex

sjlog using ch13.00c, replace
sysuse auto, clear
varextrema price if foreign
return list
sjlog close, replace
// stripdot using ch13.00c.log.tex

/*
sjlog using ch13.00, replace
*! centervars 1.0.1  CFBaum 08oct2007
program centervars, rclass
   version 10.1
   syntax varlist(numeric) [if] [in]
   marksample touse
   quietly count if `touse'
   if `r(N)' == 0  error 2000
   mata: centerv( "`varlist'", "`touse'" )
end
sjlog close, replace

sjlog using ch13.000, replace
version 10.1
mata:
void centerv( string scalar varlist, ///
              string scalar touse)
{
  st_view(X=., ., tokens(varlist), touse)
  X[ , ] = X :- mean(X)
}
end
sjlog close, replace



sjlog using ch13.01,replace
sysuse auto, clear
centervars price mpg
summarize price mpg
sjlog close, replace
*/

program drop _all
mata: mata clear

sjlog using ch13.02,replace
type centervars.ado
sjlog close, replace
// stripdot using ch13.02.log.tex

/*
*! centervars 1.0.0  CFBaum 08oct2007
program centervars, rclass
   version 10.1
   syntax varlist(numeric) [if] [in], GENerate(string) [DOUBLE]
   marksample touse
   quietly count if `touse'
   if `r(N)' == 0  error 2000
   foreach v of local varlist {
       confirm new var `generate'`v'
       generate `double' `generate'`v' = .
       local newvars "`newvars' `generate'`v'"
   }
   mata: centerv( "`varlist'", "`newvars'", "`touse'" )
end
*/
/*
version 10.1
mata:
void centerv( string scalar varlist, ///
              string scalar newvarlist,
              string scalar touse)
{
  st_view(X=., ., tokens(varlist), touse)
  st_view(Z=., ., tokens(newvarlist), touse)
  Z[ , ] = X :- mean(X)
}
end
*/
sjlog using ch13.02a, replace
type centerv.mata
sjlog close, replace
// stripdot using ch13.02a.log.tex

do centerv.mata

sjlog using ch13.03,replace
sysuse auto, clear
centervars price mpg, gen(c_)
centervars price mpg if foreign, gen(cf_) double
summarize c*
sjlog close, replace
// stripdot using ch13.03.log.tex


program drop _all
mata: mata clear
sjlog using ch13.04a, replace
type avgper.ado
sjlog close, replace
// stripdot using ch13.04a.log.tex

do avgper.mata

sjlog using ch13.04b, replace
type avgper.mata
sjlog close, replace
// stripdot using ch13.04b.log.tex

/*
*! avgper 1.0.0  CFBaum 08oct2007
program avgper, rclass
	version 10.1
	syntax varlist(max=1 numeric) [if] [in], per(integer)
// honor if and in conditions if provided
	marksample touse
	quietly count if `touse'
    if `r(N)' == 0 {
       error 2000
    }
	local newvar = "`varlist'" + "A" + string(`per')
	quietly generate `newvar' = .
* pass the varname and newvarname to Mata
	mata: avgper("`varlist'", "`newvar'",  `per', "`touse'")
	end
*/

/*
version 10.1
mata:
	void avgper(string scalar vname,
            string scalar newvname,
	            real scalar per,
	            string scalar touse)
	{      
        real matrix v1, v3
	st_view(v1=., ., vname, touse)
	st_view(v2=., ., newvname)
	v3 = colshape(v1',per) * J(per, 1, 1/per)
	v2[(1::rows(v3)),] = v3
	}
end
*/

sjlog using ch13.04, replace
use urates, clear
tsset
avgper tenn, per(3)  // calculate quarterly averages
avgper tenn, per(12) // calculate annual averages
summarize tenn*
sjlog close, replace
// stripdot using ch13.04.log.tex

sjlog using ch13.05, replace
tsmktim quarter, start(1978q1) // create quarterly calendar var
tsmktim year, start(1978)      // create annual calendar var
list t tenn quarter tennA3 year tennA12 in 1/12, sep(3)
sjlog close, replace
// stripdot using ch13.05.log.tex

use urates, clear
sjlog using ch13.06, replace
foreach v of varlist tenn-arkansas {
	avgper `v', per(3)
}
summarize tenn-arkansasA3, sep(6)
sjlog close, replace
// stripdot using ch13.06.log.tex

sjlog using ch13.07, replace
type aggreg.ado
sjlog close, replace
// stripdot using ch13.07.log.tex
/*
program aggreg, rclass
	version 10.1
	syntax varlist(max=1 numeric) [if] [in], per(integer) [func(string)]
	marksample touse
	quietly count if `touse'
	if `r(N)' == 0 {
	        error 2000
	}
* validate per versus selected sample
	if `per' <= 0 | `per' >= `r(N)' {
		display as error "per must be > 0 and < N of observations."
		error 198
	}
	if mod(`r(N)',`per' != 0) {
		display as error "N of observations must be a multiple of per."
		error 198
	}
* validate func option; default is average (code A)
    local ops A S F L
    local opnames average sum first last
    if "`func'" == "" {
    	local op "A"
    }
    else {
    	local nop : list posof "`func'" in opnames
    	if !`nop' {
    		display as err "Error: func must be chosen from `opnames'"
    		error 198
    	}
    	local op : word `nop' of `ops'
    }
* validate the new varname
	local newvar = "`varlist'`op'`per'"
     quietly generate `newvar' = .
* pass the varname and newvarname to Mata
	mata: aggreg("`varlist'", "`newvar'",  `per', "`op'", "`touse'")
	end
*/

do aggreg.mata

sjlog using ch13.08, replace
type aggreg.mata
sjlog close, replace
// stripdot using ch13.08.log.tex

/*
sjlog using ch13.08, replace
version 10.1
mata:
void aggreg(string scalar vname,
            string scalar newvname,
	            real scalar per,
	        string scalar op,
	            string scalar touse)
	{
	real colvector mult
	if (op=="A") {
	     mult = J(per, 1, 1/per)
	}
	else if (op=="S") {
	     mult = J(per, 1, 1)
	}
	else if (op=="F") {
		 mult = J(per, 1, 0)
		 mult[1] = 1
	}
	else if (op=="L") {
	     mult = J(per, 1, 0)
	     mult[per] = 1
	}
	st_view(v1=., ., vname, touse)
	st_view(v2=., ., newvname)
	v3 = colshape(v1', per) * mult
	v2[(1::rows(v3)),] = v3
	}
end
sjlog close, replace
*/

* webuse urates, clear
clear

sjlog using ch13.09, replace
use urates
aggreg tenn, per(3)  // calculate quarterly averages
aggreg tenn, per(3) func(sum) // calculate quarterly sum
aggreg tenn, per(3) func(first) // extract first month's value
aggreg tenn, per(3) func(last) // extract first month's value
tsmktim quarter, start(1978q1) // create quarterly calendar var
list t tenn quarter tennA3 tennS3 tennF3 tennL3 in 1/12, sep(3)
sjlog close, replace
// stripdot using ch13.09.log.tex

/*
sjlog using appB.24a, replace
// save the compiled averageper function 
mata: mata mosave averageper(), replace
sjlog close, replace
*/

do gbpval.mata

sjlog using ch13.10, replace
type gbpval.mata
sjlog close, replace
// stripdot using ch13.10.log.tex

do gbpval2.mata

sjlog using ch13.11, replace
type gbpval2.mata
sjlog close, replace
// stripdot using ch13.11.log.tex

do gbpval3.mata

sjlog using ch13.12, replace
type gbpval3.mata
sjlog close, replace
// stripdot using ch13.12.log.tex
