* ITSP 14.9

capt log close
set rmsg off
set more off
program drop _all

sjlog using ch14.9b, replace
type mygmm2s.ado
sjlog close, replace
// stripdot using ch14.9b.log.tex

set matastrict on
do m_mygmm2s.mata

sjlog using ch14.9c, replace
type m_mygmm2s.mata
sjlog close, replace
// stripdot using ch14.9c.log.tex

do m_myomega.mata

sjlog using ch14.9d, replace
type m_myomega.mata
sjlog close, replace
// stripdot using ch14.9d.log.tex

sjlog using ch14.9e, replace
type mygmmcue.ado
sjlog close, replace
// stripdot using ch14.9e.log.tex

do m_mygmmcue.mata

sjlog using ch14.9f, replace
type m_mygmmcue.mata
sjlog close, replace
// stripdot using ch14.9f.log.tex

do m_mycuecrit.mata

sjlog using ch14.9g, replace
type m_mycuecrit.mata
sjlog close, replace
// stripdot using ch14.9g.log.tex

sjlog using ch14.9, replace
cscript mygmm2s adofile mygmm2s
set more off

mata: mata clear
program drop _all
// use http://fmwww.bc.edu/ec-p/data/hayashi/griliches76.dta, clear
use griliches76, clear
quietly ivreg2 lw s expr tenure rns smsa  (iq=med kww age mrt), gmm2s 
savedresults save ivhomo e()
mygmm2s lw, endog(iq) inexog(s expr tenure rns smsa) ///
            exexog(med kww age mrt)
savedresults compare ivhomo e(), include(macros: depvar scalar: N j matrix: b V) ///
             tol(1e-7) verbose

quietly ivreg2 lw s expr tenure rns smsa  (iq=med kww age mrt), gmm2s robust
savedresults save ivrobust e()
quietly mygmm2s lw, endog(iq) inexog(s expr tenure rns smsa) ///
                    exexog(med kww age mrt) robust
savedresults compare ivrobust e(), include(macros: depvar scalar: N j matrix: b V) /// 
             tol(1e-7) verbose
sjlog close, replace
// stripdot using ch14.9.log.tex

sjlog using ch14.9a, replace
cscript mygmmcue adofile mygmmcue
set more off
mata: mata clear
program drop _all
set rmsg on
use griliches76, clear

quietly ivreg2 lw s expr tenure rns smsa  (iq=med kww age mrt), cue 
savedresults save ivreg2cue e()
mygmmcue lw, endog(iq) inexog(s expr tenure rns smsa) ///
            exexog(med kww age mrt)
savedresults compare ivreg2cue e(), include(macros: depvar scalar: N j matrix: b V) ///
             tol(1e-4) verbose
             
quietly ivreg2 lw s expr tenure rns smsa  (iq=med kww age mrt), cue robust
savedresults save ivreg2cue e()
mygmmcue lw, endog(iq) inexog(s expr tenure rns smsa) ///
            exexog(med kww age mrt) robust
savedresults compare ivreg2cue e(), include(macros: depvar scalar: N j matrix: b V) ///
             tol(1e-4) verbose
sjlog close, replace
// stripdot using ch14.9a.log.tex
// use http://fmwww.bc.edu/ec-p/data/hayashi/griliches76.dta, clear
set rmsg off
set more on
