use census2c,clear
sjlog using ch3.01, replace
summarize pop*
sjlog close, replace
// stripdot using ch3.01.log.tex

sjlog using ch3.02, replace
list state pop in 1/5
list state pop medage if medage >= 32
sjlog close, replace
// stripdot using ch3.02.log.tex

sjlog using ch3.03, replace
encode state, generate(stateid)
describe state stateid
list state stateid in 1/5
sjlog close, replace
// stripdot using ch3.03.log.tex

// sjlog using ch3.04, replace
// sort pop
// generate byte sizecat = group(3)
// sjlog close, replace

sjlog using ch3.04, replace
decode stateid, generate(statename)
list stateid statename in 1/5
sjlog close, replace
// stripdot using ch3.04.log.tex

sjlog using ch3.05, replace
generate size=irecode(pop, 1000, 4000, 8000, 20000)
label define popsize 0 "<1m" 1 "1-4m" 2 "4-8m" 3 ">8m"
label values size popsize
tabstat pop, stat(mean min max) by(size)
sjlog close, replace
// stripdot using ch3.05.log.tex

// tabstat pop, stat(mean min max) by(sizecat)
// list state pop if sizecat==1, sep(0)

sjlog using ch3.06, replace
generate byte newengland = inlist(state, "Connecticut", "Maine", ///
"Massachusetts", "New Hampshire", "Rhode Island", "Vermont")
sort medage
list state medage pop if newengland, sep(0)
sjlog close,replace
// stripdot using ch3.06.log.tex

sjlog using ch3.07, replace
list state medage pop if inrange(pop, 5000, 9999), sep(0)
sjlog close, replace
// stripdot using ch3.07.log.tex

sjlog using ch3.07a, replace
generate medagebrack = recode(medage, 29, 30, 31, 32, 33)
tabulate medagebrack
sjlog close, replace
// stripdot using ch3.07a.log.tex

sjlog using ch3.07b, replace
generate medagebracknr = irecode(medage, 29, 30, 31, 32, 33)
tabulate medagebracknr
sjlog close, replace
// stripdot using ch3.07b.log.tex

sjlog using ch3.07c, replace
xtile medagequart = medage, nq(4)
tabstat medage, stat(n mean min max) by(medagequart)
sjlog close, replace
// stripdot using ch3.07c.log.tex

// undocumented egen avgpop = mean(pop), by(size)
sjlog using ch3.08, replace
bysort size: egen avgpop = mean(pop)
generate popratio = 100 * pop / avgpop
format popratio %7.2f
list state pop avgpop popratio if size == 0, sep(0)
sjlog close, replace
// stripdot using ch3.08.log.tex

// sjlog using ch3.09, replace
// tabulate size, generate(popsize)
// egen countcat = rcount(popsize*), cond(@==1)
// summarize countcat
// sjlog close, replace
