* ITSP 6.5 -

set more off

sjlog using ch6.5, replace
use airquality, clear
// estimate with OLS
qui regress so2 pop manuf wind 
mfx compute, eyex
matrix nu =  e(Xmfx_eyex)
estadd scalar nu = nu[1, 1]
matrix nuse = e(Xmfx_se_eyex)
estadd scalar nuse = nuse[1, 1]
estimates store one
// reestimate using IV
qui ivregress 2sls so2 (pop = temp precip) manuf wind
mfx compute, eyex
matrix nu =  e(Xmfx_eyex)
estadd scalar nu = nu[1, 1]
matrix nuse = e(Xmfx_se_eyex)
estadd scalar nuse = nuse[1, 1]
estimates store two
sjlog close, replace
// stripdot using ch6.5.log.tex

sjlog using ch6.5a, replace
esttab one two, mtitles("OLS" "IV") stat(nu nuse, labels("Elas.(pop)" "SE"))
sjlog close, replace
// stripdot using ch6.5a.log.tex

sjlog using ch6.5b, replace
qui summarize so2, detail
generate hiso2 = (so2 > r(p50)) & !missing(so2)
summarize precip, meanonly
generate hiprecip = (precip > r(mean)) & !missing(precip)
qui probit hiso2 pop manuf
mfx compute
estimates store three
qui probit hiso2 pop manuf hiprecip
mfx compute
estimates store four
sjlog close, replace
// stripdot using ch6.5b.log.tex

sjlog using ch6.5c, replace
esttab three four, margin
sjlog close, replace
// stripdot using ch6.5c.log.tex
