
* ITSP 6.6 - 

set more off

sjlog using ch6.6, replace
use air2, clear
* put a timeseries calendar on the data
tsmktim ym, start(1949m1)
* get the month number
generate mnr = month(dofm(ym))
* find the end-of-quarter months
generate eoq = (mod(mnr, 3) == 0)
list ym mnr eoq air in 1/16, sep(4) noobs
sjlog close, replace
// stripdot using ch6.6.log.tex

preserve
sjlog using ch6.6a, replace
// keep only last month of quarter
keep if eoq
tsmktim yq, start(1949q1)
list yq air in 1/16, sep(4) noobs
sjlog close, replace
// stripdot using ch6.6a.log.tex
restore
preserve

sjlog using ch6.6b, replace
// sum the values over the quarter
generate qtr = qofd(dofm(ym))
format qtr %tq
collapse (sum) airsum=air, by(qtr)
tsmktim yq, start(1949q1)
list yq airsum in 1/16, sep(4) noobs
sjlog close, replace
// stripdot using ch6.6b.log.tex

restore
preserve
sjlog using ch6.6c, replace
// average the values over the quarter
generate qtr = qofd(dofm(ym))
format qtr %tq
collapse airavg=air, by(qtr)
tsmktim yq, start(1949q1)
list yq airavg in 1/16, sep(4) noobs
sjlog close, replace
// stripdot using ch6.6c.log.tex

restore
sjlog using ch6.6d, replace
tsset ym
tscollap (last) aireoq=air (sum) airsum=air (mean) airavg=air, to(q) gen(yq)
list in 1/16, sep(4) noobs
sjlog close, replace
// stripdot using ch6.6d.log.tex
