* itsp ch7.00 - 7.10

set more off

sjlog using ch7.00, replace
use bpress, clear
bysort sex agegrp: summarize bp
sjlog close, replace
// stripdot using ch7.00.log.tex

use bpress, clear
sjlog using ch7.01, replace
xi: regress bp i.agegrp i.sex
sjlog close, replace
// stripdot using ch7.01.log.tex

sjlog using ch7.02, replace
xi: regress bp i.agegrp*i.sex
sjlog close, replace
// stripdot using ch7.02.log.tex

sjlog using ch7.03, replace
xi: regress bp i.agegrp*bp0
sjlog close, replace
// stripdot using ch7.03.log.tex

sjlog using ch7.04, replace
statsby mean=r(mean) sd=r(sd) n=r(N), by(agegrp sex) saving(bpstats, replace): summarize bp
use bpstats, clear
list, sepby(agegrp)
sjlog close, replace
// stripdot using ch7.04.log.tex

sjlog using ch7.05, replace
use ibm, clear
rolling _b _se, window(90) saving(capm, replace) nodots: qreg ibm spx
sjlog close, replace
// stripdot using ch7.05.log.tex

sjlog using ch7.06, replace
use capm, clear
label var _b_spx "quantile reg IBM beta"
label var end "date"
list in 1/5
sjlog close, replace
// stripdot using ch7.06.log.tex

sjlog using ch7.07, replace
tsset end
format end %tdMonYY
tsline _b_spx, yline(1) saving(fig7_1, replace) scheme(s2mono)
sjlog close, replace
// stripdot using ch7.07.log.tex
graph display, xsize(4) ysize(3)
graph export fig7_1.eps, replace

program drop _all
sjlog using ch7.08, replace
type simpctile.ado
sjlog close, replace
// stripdot using ch7.08.log.tex

sjlog using ch7.09, replace
clear
set seed 2007062926
simulate p25=r(p25) p50=r(p50) p75=r(p75), reps(1000) nodots ///
         saving(pctiles, replace): simpctile
sjlog close, replace
// stripdot using ch7.09.log.tex

// set obs 1000

sjlog using ch7.10, replace
use pctiles, clear
summarize
label var p50 "Sample median"
histogram p50, normal saving(fig7_2, replace) scheme(s2mono)
sjlog close, replace
// stripdot using ch7.10.log.tex
graph display, xsize(4) ysize(3)
graph export fig7_2.eps, replace

sjlog using ch7.11, replace
use bpress, clear
set seed 2007062926
ttest bp, by(sex)
bootstrap diff=( r(mu_1) - r(mu_2) ), nodots: ttest bp, by(sex)
sjlog close, replace
// stripdot using ch7.11.log.tex

sjlog using ch7.12, replace
use pctiles, clear
qnorm p50, saving(fig7_3, replace) scheme(s2mono)
sjlog close, replace
graph display, xsize(4) ysize(3)
graph export fig7_3.eps, replace
// stripdot using ch7.12.log.tex

