* tipBizday
// cd /Users/baum/doc/Stata/sjlatex/
capture erase bizday1.log
capture erase bizday1.log.tex
sjlog using bizday1,replace
clear
freduse DTB3
rename daten caldate
tsset caldate
keep if tin(1aug2005,)
label var caldate date
sjlog close
// tsline DTB3
// graph export bizday1.eps,replace

capture erase bizday2.log
capture erase bizday2.log.tex
sjlog using bizday2,replace
quietly generate byte notmiss = DTB3 < .
quietly generate seqdate = cond(notmiss,sum(notmiss),.)
tsset seqdate
sjlog close

capture erase bizday3.log
capture erase bizday3.log.tex
sjlog using bizday3,replace
quietly generate dDTB3 = D.DTB3
label var dDTB3 "Daily change in 3-mo Treasury rate"
tsset caldate
tsline dDTB3, yline(0) scheme(s2mono)
sjlog close

graph export bizday2.eps, replace
stripdot using bizday3.log.tex
graph display, xsize(4) ysize(3)
graph export fig6_3.eps, replace



/*
quietly regress dDTB3 L(1/5).dDTB3
predict double dDTB3hat, xb
*/

capture erase bizday4.log
capture erase bizday4.log.tex
sjlog using bizday4,replace
tsset seqdate
quietly generate dcal = D.caldate if seqdate < .
quietly generate month = mofd(caldate) if seqdate < .
format %tm month 
sort month (seqdate)
quietly by month: generate adjchange = sum(dDTB3/sqrt(dcal))
quietly by month: generate sumchange = adjchange if _n==_N & month < .
list month sumchange if sumchange < ., sep(0) noobs
sjlog close







