@echo off
rem DOS batch file to LaTeX a Stata Press book
rem version 1.0.3  03aug2005

set PS=ps
:beginloop
if "%1" EQU "nops" set PS=nops
if "%1" EQU "h" goto help
if "%1" EQU "help" goto help
if "%1" EQU "clean" goto clean

shift
if "%1" NEQ "" goto beginloop
:endloop

goto skiphelp

:help
echo usage: %0 [option(s)]
echo.
echo Run LaTeX, BibTeX, and Makeindex to create a Stata Press book.
echo.
echo Options:
echo         help	Display this information and quit
echo         nops	do not generate a PostScript file

goto exit

:clean
echo %0:  cleaning auxiliary files
del *.aux *.lof *.lot *.toc *.mtc* *.ind
goto exit

:skiphelp

latex main
if errorlevel 1 goto latexerror
echo.
bibtex main > bibtex.log
if errorlevel 1 goto bibtexerror
echo.
latex main
if errorlevel 1 goto latexerror
echo.
makeindex -s dot.ist author.idx > makeindex.log
if errorlevel 1 goto indexerror
echo.
makeindex -s dot.ist subject.idx >> makeindex.log
if errorlevel 1 goto indexerror

echo.
latex main
if errorlevel 1 goto latexerror

if "%PS%" NEQ "ps" goto dvimsg
echo.
echo Generating PostScript file:
dvips main.dvi -o main.ps
if errorlevel 1 goto dvipserror
echo.
echo %0: finished...
echo %0: you may now view main.ps
goto exit

:latexerror
echo %0: error when running latex
goto exit

:bibtexerror
echo %0: error when running bibtex
goto exit

:indexerror
echo %0: error when running makeindex
goto exit

:dvipserror
echo %0: error when running dvips
goto exit

:dvimsg
echo.
echo %0: finished...
echo %0: you may now view main.dvi

:exit
